--- asterisk-11.2.1.orig/res/res_agi.c	2012-10-04 17:42:07.000000000 +0200
+++ asterisk-11.2.1/res/res_agi.c	2013-03-19 21:17:18.286734792 +0100
@@ -1234,7 +1234,7 @@ static enum agi_result async_agi_read_fr
 	return AGI_RESULT_SUCCESS;
 }
 
-static enum agi_result launch_asyncagi(struct ast_channel *chan, char *argv[], int *efd)
+static enum agi_result launch_asyncagi(struct ast_channel *chan, int argc, char *argv[], int *efd)
 {
 /* This buffer sizes might cause truncation if the AGI command writes more data
    than AGI_BUF_SIZE as result. But let's be serious, is there an AGI command
@@ -1300,7 +1300,7 @@ static enum agi_result launch_asyncagi(s
 
 	/* notify possible manager users of a new channel ready to
 	   receive commands */
-	setup_env(chan, "async", fds[1], 0, 0, NULL);
+	setup_env(chan, "async", fds[1], 0, argc, argv);
 	/* read the environment */
 	res = read(fds[0], agi_buffer, AGI_BUF_SIZE);
 	if (res <= 0) {
@@ -1615,7 +1615,7 @@ static enum agi_result launch_ha_netscri
 	return AGI_RESULT_FAILURE;
 }
 
-static enum agi_result launch_script(struct ast_channel *chan, char *script, char *argv[], int *fds, int *efd, int *opid)
+static enum agi_result launch_script(struct ast_channel *chan, char *script, int argc, char *argv[], int *fds, int *efd, int *opid)
 {
 	char tmp[256];
 	int pid, toast[2], fromast[2], audio[2], res;
@@ -1628,7 +1628,7 @@ static enum agi_result launch_script(str
 		return (efd == NULL) ? launch_ha_netscript(script, argv, fds) : AGI_RESULT_FAILURE;
 	}
 	if (!strncasecmp(script, "agi:async", sizeof("agi:async") - 1)) {
-		return launch_asyncagi(chan, argv, efd);
+		return launch_asyncagi(chan, argc, argv, efd);
 	}
 
 	if (script[0] != '/') {
@@ -3896,7 +3896,7 @@ static int agi_exec_full(struct ast_chan
 			return -1;
 	}
 #endif
-	res = launch_script(chan, args.argv[0], args.argv, fds, enhanced ? &efd : NULL, &pid);
+	res = launch_script(chan, args.argv[0], args.argc, args.argv, fds, enhanced ? &efd : NULL, &pid);
 	/* Async AGI do not require run_agi(), so just proceed if normal AGI
 	   or Fast AGI are setup with success. */
 	if (res == AGI_RESULT_SUCCESS || res == AGI_RESULT_SUCCESS_FAST) {

